Package org.eclipse.emf.cdo.common.protocol

## Interface CDODataOutput

- All Superinterfaces:
    `java.io.DataOutput`, `org.eclipse.net4j.util.io.ExtendedDataOutput`
  All Known Implementing Classes:
    `CDODataOutputImpl`

      public interface CDODataOutput
      extends org.eclipse.net4j.util.io.ExtendedDataOutput

  Provides I/O methods for writing various CDO data types and concepts to streams.
  Since:
    3.0
  Author:
    Eike Stepper
  No Implement
    This interface is not intended to be implemented by clients.
  No Extend
    This interface is not intended to be extended by clients.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.eclipse.net4j.util.io.ExtendedDataOutput

      `org.eclipse.net4j.util.io.ExtendedDataOutput.Delegating, org.eclipse.net4j.util.io.ExtendedDataOutput.Stream`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `CDOIDProvider` | `getIDProvider()` |
    `CDOPackageRegistry` | `getPackageRegistry()` |
    `CDOPermissionProvider` | `getPermissionProvider()` |
    `CDORevisionUnchunker` | `getRevisionUnchunker()` |
    `void` | `writeCDOBranch​(CDOBranch branch)` |
    `void` | `writeCDOBranchPoint​(CDOBranchPoint branchPoint)` |
    `void` | `writeCDOBranchVersion​(CDOBranchVersion branchVersion)` |
    `void` | `writeCDOChangeSetData​(CDOChangeSetData changeSetData)` |
    `void` | `writeCDOClassifierRef​(CDOClassifierRef eClassifierRef)` |
    `void` | `writeCDOClassifierRef​(org.eclipse.emf.ecore.EClassifier eClassifier)` |
    `void` | `writeCDOCommitData​(CDOCommitData commitData)` |
    `void` | `writeCDOCommitInfo​(CDOCommitInfo commitInfo)` |
    `void` | `writeCDOFeatureDelta​(org.eclipse.emf.ecore.EClass owner, CDOFeatureDelta featureDelta)` |
    `void` | `writeCDOFeatureValue​(org.eclipse.emf.ecore.EStructuralFeature feature, java.lang.Object value)` |
    `void` | `writeCDOID​(CDOID id)` |
    `void` | `writeCDOIDAndBranch​(CDOIDAndBranch idAndBranch)` |
    `void` | `writeCDOIDAndVersion​(CDOIDAndVersion idAndVersion)` |
    `void` | `writeCDOIDReference​(CDOIDReference idReference)` |
    `void` | `writeCDOList​(org.eclipse.emf.ecore.EClass owner, org.eclipse.emf.ecore.EStructuralFeature feature, CDOList list, int referenceChunk)` |
    `void` | `writeCDOLockArea​(IDurableLockingManager.LockArea lockArea)` |
    `void` | `writeCDOLockChangeInfo​(CDOLockChangeInfo lockChangeInfo)` |
    `void` | `writeCDOLockChangeInfo​(CDOLockChangeInfo lockChangeInfo, java.util.Set<CDOID> filter)` |
    `void` | `writeCDOLockOwner​(CDOLockOwner lockOwner)` |
    `void` | `writeCDOLockState​(CDOLockState lockState)` |
    `void` | `writeCDOLockType​(org.eclipse.net4j.util.concurrent.IRWLockManager.LockType lockType)` |
    `void` | `writeCDOPackageInfo​(CDOPackageInfo packageInfo)` |
    `void` | `writeCDOPackageUnit​(CDOPackageUnit packageUnit, boolean withPackages)` |
    `void` | `writeCDOPackageUnits​(CDOPackageUnit... packageUnit)` |
    `void` | `writeCDOPackageUnitType​(CDOPackageUnit.Type type)` |
    `void` | `writeCDOPackageURI​(java.lang.String uri)` |
    `void` | `writeCDORevisable​(CDORevisable revisable)` |
    `void` | `writeCDORevision​(CDORevision revision, int referenceChunk)` |
    `void` | `writeCDORevision​(CDORevision revision, int referenceChunk, CDOBranchPoint securityContext)` |
    `void` | `writeCDORevisionDelta​(CDORevisionDelta revisionDelta)` |
    `void` | `writeCDORevisionKey​(CDORevisionKey revisionKey)` |
    `void` | `writeCDORevisionOrPrimitive​(java.lang.Object value)` | Write either a CDORevision or a primitive value.
    `void` | `writeCDORevisionOrPrimitiveOrClassifier​(java.lang.Object value)` | Write either a CDORevision, a primitive value or a EClass.
    `void` | `writeCDOType​(CDOType cdoType)` |
    `void` | `writeXInt​(int v)` |
    `void` | `writeXLong​(long v)` |

    - ### Methods inherited from interface java.io.DataOutput

      `write, write, write, writeBoolean, writeByte, writeBytes, writeChar, writeChars, writeDouble, writeFloat, writeInt, writeLong, writeShort, writeUTF`

    - ### Methods inherited from interface org.eclipse.net4j.util.io.ExtendedDataOutput

      `writeByteArray, writeEnum, writeException, writeObject, writeString, writeVarInt, writeVarLong`

- - ### Method Detail

    - #### writeXInt

          void writeXInt​(int v)
                  throws java.io.IOException

      Throws:
        `java.io.IOException`
      Since:
        4.6

    - #### writeXLong

          void writeXLong​(long v)
                   throws java.io.IOException

      Throws:
        `java.io.IOException`
      Since:
        4.6

    - #### getPackageRegistry

          CDOPackageRegistry getPackageRegistry()

    - #### getIDProvider

          CDOIDProvider getIDProvider()

    - #### getPermissionProvider

          CDOPermissionProvider getPermissionProvider()

      Since:
        4.1

    - #### getRevisionUnchunker

          CDORevisionUnchunker getRevisionUnchunker()

      Since:
        4.3

    - #### writeCDOPackageUnit

          void writeCDOPackageUnit​(CDOPackageUnit packageUnit,
                                   boolean withPackages)
                            throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeCDOPackageUnits

          void writeCDOPackageUnits​(CDOPackageUnit... packageUnit)
                             throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeCDOPackageUnitType

          void writeCDOPackageUnitType​(CDOPackageUnit.Type type)
                                throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeCDOPackageInfo

          void writeCDOPackageInfo​(CDOPackageInfo packageInfo)
                            throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeCDOClassifierRef

          void writeCDOClassifierRef​(CDOClassifierRef eClassifierRef)
                              throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeCDOClassifierRef

          void writeCDOClassifierRef​(org.eclipse.emf.ecore.EClassifier eClassifier)
                              throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeCDOPackageURI

          void writeCDOPackageURI​(java.lang.String uri)
                           throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeCDOType

          void writeCDOType​(CDOType cdoType)
                     throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeCDOBranch

          void writeCDOBranch​(CDOBranch branch)
                       throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeCDOBranchPoint

          void writeCDOBranchPoint​(CDOBranchPoint branchPoint)
                            throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeCDOBranchVersion

          void writeCDOBranchVersion​(CDOBranchVersion branchVersion)
                              throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeCDOChangeSetData

          void writeCDOChangeSetData​(CDOChangeSetData changeSetData)
                              throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeCDOCommitData

          void writeCDOCommitData​(CDOCommitData commitData)
                           throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeCDOCommitInfo

          void writeCDOCommitInfo​(CDOCommitInfo commitInfo)
                           throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeCDOID

          void writeCDOID​(CDOID id)
                   throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeCDOIDReference

          void writeCDOIDReference​(CDOIDReference idReference)
                            throws java.io.IOException

      Throws:
        `java.io.IOException`
      Since:
        4.0

    - #### writeCDOIDAndVersion

          void writeCDOIDAndVersion​(CDOIDAndVersion idAndVersion)
                             throws java.io.IOException

      Throws:
        `java.io.IOException`
      Since:
        4.0

    - #### writeCDOIDAndBranch

          void writeCDOIDAndBranch​(CDOIDAndBranch idAndBranch)
                            throws java.io.IOException

      Throws:
        `java.io.IOException`
      Since:
        4.0

    - #### writeCDORevisionKey

          void writeCDORevisionKey​(CDORevisionKey revisionKey)
                            throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeCDORevision

          void writeCDORevision​(CDORevision revision,
                                int referenceChunk)
                         throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeCDORevision

          void writeCDORevision​(CDORevision revision,
                                int referenceChunk,
                                CDOBranchPoint securityContext)
                         throws java.io.IOException

      Throws:
        `java.io.IOException`
      Since:
        4.1

    - #### writeCDORevisable

          void writeCDORevisable​(CDORevisable revisable)
                          throws java.io.IOException

      Throws:
        `java.io.IOException`
      Since:
        4.0

    - #### writeCDOList

          void writeCDOList​(org.eclipse.emf.ecore.EClass owner,
                            org.eclipse.emf.ecore.EStructuralFeature feature,
                            CDOList list,
                            int referenceChunk)
                     throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeCDOFeatureValue

          void writeCDOFeatureValue​(org.eclipse.emf.ecore.EStructuralFeature feature,
                                    java.lang.Object value)
                             throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeCDORevisionDelta

          void writeCDORevisionDelta​(CDORevisionDelta revisionDelta)
                              throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeCDOFeatureDelta

          void writeCDOFeatureDelta​(org.eclipse.emf.ecore.EClass owner,
                                    CDOFeatureDelta featureDelta)
                             throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeCDORevisionOrPrimitive

          void writeCDORevisionOrPrimitive​(java.lang.Object value)
                                    throws java.io.IOException

      Write either a CDORevision or a primitive value.
      Throws:
        `java.io.IOException`

    - #### writeCDORevisionOrPrimitiveOrClassifier

          void writeCDORevisionOrPrimitiveOrClassifier​(java.lang.Object value)
                                                throws java.io.IOException

      Write either a CDORevision, a primitive value or a EClass.
      Throws:
        `java.io.IOException`

    - #### writeCDOLockType

          void writeCDOLockType​(org.eclipse.net4j.util.concurrent.IRWLockManager.LockType lockType)
                         throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeCDOLockChangeInfo

          void writeCDOLockChangeInfo​(CDOLockChangeInfo lockChangeInfo)
                               throws java.io.IOException

      Throws:
        `java.io.IOException`
      Since:
        4.1

    - #### writeCDOLockChangeInfo

          void writeCDOLockChangeInfo​(CDOLockChangeInfo lockChangeInfo,
                                      java.util.Set<CDOID> filter)
                               throws java.io.IOException

      Throws:
        `java.io.IOException`
      Since:
        4.12

    - #### writeCDOLockState

          void writeCDOLockState​(CDOLockState lockState)
                          throws java.io.IOException

      Throws:
        `java.io.IOException`
      Since:
        4.1

    - #### writeCDOLockOwner

          void writeCDOLockOwner​(CDOLockOwner lockOwner)
                          throws java.io.IOException

      Throws:
        `java.io.IOException`
      Since:
        4.1

    - #### writeCDOLockArea

          void writeCDOLockArea​(IDurableLockingManager.LockArea lockArea)
                         throws java.io.IOException

      Throws:
        `java.io.IOException`
      Since:
        4.1